#include "../main.h"
#include <cmath>

namespace dfosfor{

void plot(int x, int y, float c);
//    plot the pixel at (x, y) with brightness c

// Ganzzahliger Teil von x
int ipart(float x) {return int(x);}

int round(float x) {return ipart(x + 0.5f);}

// Bruchteil von x
float fpart(float x) {if (x<0) return 1 - (x - floor(x)); return x - floor(x);}

float rfpart(float x) {return 1 - fpart(x);}

void drawLine(float x0, float y0, float x1, float y1) {
 bool steep = fabs(y1 - y0) > fabs(x1 - x0);

 if (steep) {swap(x0,y0); swap(x1,y1);}
 if (x0>x1) {swap(x0,x1); swap(y0,y1);}

 float dx = x1 - x0,
       dy = y1 - y0,
       gradient = dy / dx;
    // Vorgehen fr ersten Endpunkt
 int xend = round(x0);
 float yend = y0 + gradient * (xend - x0),
       xgap = rfpart(x0 + 0.5f);
 int xpxl1 = xend; // fr die Hauptschleife
 int ypxl1 = ipart(yend);
 if (steep) {
  plot(ypxl1,   xpxl1, rfpart(yend) * xgap);
  plot(ypxl1+1, xpxl1,  fpart(yend) * xgap);
 }else{
  plot(xpxl1, ypxl1  , rfpart(yend) * xgap);
  plot(xpxl1, ypxl1+1,  fpart(yend) * xgap);
 }
 float intery = yend + gradient; // erste y-Koordinate fr die Hauptschleife
    // Vorgehen fr ersten Endpunkt
 xend = round(x1);
 yend = y1 + gradient * (xend - x1);
 xgap = fpart(x1 + 0.5f);
 int xpxl2 = xend, // fer die Hauptschleife
     ypxl2 = ipart(yend);
 if (steep) {
  plot(ypxl2  , xpxl2, rfpart(yend) * xgap);
  plot(ypxl2+1, xpxl2,  fpart(yend) * xgap);
 }else{
  plot(xpxl2, ypxl2,  rfpart(yend) * xgap);
  plot(xpxl2, ypxl2+1, fpart(yend) * xgap);
 }
    // Hauptschleife
 for (int x=xpxl1+1; x<=xpxl2 - 1; x++) {
  if (steep) {
   plot(ipart(intery)  , x, rfpart(intery));
   plot(ipart(intery)+1, x,  fpart(intery));
  }else{
   plot(x, ipart(intery),  rfpart(intery));
   plot(x, ipart(intery)+1, fpart(intery));
  }
  intery+=gradient;
 }
}
}
