#include <cmath>	// in w2k3ddk/inc/crt/, unbedingt vor plotxy.h
#include "tick.h"
#include "../util/util.h"	// isfinite
#include "../util/compat.h"	// lrint

TCHAR toUnitPrefix(Float&x,Float aufloes,WORD allow) {
 if (aufloes<0) aufloes=-aufloes;	// sollte nie passieren
 Float g=fabs(x);
 if (g<aufloes) g=aufloes;		// Maximum beider
 if (!g) return 0;			// Kein Einheitenprfix
 const Float log1000=log(1000.0F);
 char b=(char)lrint(floor(log(g)/log1000));
 if (!b || b<-8 || b>8) return 0;
 char bit=b<0?b+8:b+7;			// Bit-Bereich 0..15
 if (!(allow>>bit&1)) return 0;		// Nicht erlaubter Einheitenvorsatz (ks = Kilosekunde: Unblich!)
 x/=pow(1000.0F,b);			// x verndern
 return TEXT("yzafpnmkMGPTEZY")[bit];	// Prfix als Buchstabe liefern, in UTF-8 geht das so nicht (fr's )
}

Float roundToMultiple(Float x, Float mult) {
  if (!mult) return x;			// nicht runden
  if (!my::isfinite(mult)) return x;	// nicht runden
  return Float(::ceil(x/mult))*mult;	// mult>0: aufrunden, mult<0: abrunden
}

Float roundToLog(Float x, Float base) {
 Float b=base;
 if (x<0) {x=-x; base=-base;}
#if _MSC_VER > 1900
 auto roundfunc=ceilf;
#else
 Float(*roundfunc)(Float)=ceilf;
#endif
 if (b<0) {b=-b; roundfunc=floorf;}
 return Float(pow(base,roundfunc(Float(log(x)/log(b)))));
}

Float roundWithMethod(Float x,DWORD flags,char dir) {
  if (!x) return 0;
  if (!my::isfinite(x)) DebugBreak();
  if (x<0) return -roundWithMethod(-x,flags,-dir);
  Float base=10;
  static const Float p[]={1};
  const Float*points=p;	// ganze Zahlen
  int plen=1;
  switch ((flags>>16)&0x0F) {
    case 1: {	// 1-3-10
      static const Float p[]={1,3}; points=p; plen=elemof(p);
    }break;
    case 2: {	// 1-2-5-10
      static const Float p[]={1,2,5}; points=p; plen=elemof(p);
    }break;
    case 3: {	// 60er-Reihe (fr Zeitangaben im Minuten- und Stundenbereich)
      base=60;
      static const Float p[]={1,2,5,10,30}; points=p; plen=elemof(p);
    }break;
    case 4: {	// E12-Reihe (oder exakte Logarithmen?)
      static const Float p[]={1,1.2F,1.5F,1.8F,2.2F,2.7F,3.3F,3.9F,4.7F,5.6F,6.8F,8.2F}; points=p; plen=elemof(p);
    }break;
    case 5: {	// binr
      base = 2;
    }break;
    case 6: {	// Vielfache von PI
      base = Float(PI);
    }break;
  }
//  points.push(base);	// hintenan fr Algorithmusvereinfachung
  Float fl=Float(::floor(::log(x)/::log(base)));
  Float fb=Float(::pow(base,fl));
  Float y=x/fb;	// nun im Bereich 1..9,999
  int i;
  if (dir>0) {
    for (i=0; i<plen; i++) {
      if (y<=points[i]) {y=points[i]; break;}	// aufrunden
    }
    if (i==plen) y=base;	// ggf. auf nchste Basis
  }else if (dir<0) {
    for (i=plen; --i>=0;) {
      if (y>=points[i]) {y=points[i]; break;}	// abrunden
    }
  }
  return y*fb;	// Kommastelle setzen
}

